require("nvim-treesitter.configs").setup({
	ensure_installed = {
		"bash",
		"css",
		"html",
		"json",
		"json5",
		"jsonc",
		"lua",
		"rasi",
		"regex",
		"scss",
		"toml",
		"vim",
		"yaml",
	},
	highlight = {
		enable = true,
		use_languagetree = true,
		additional_vim_regex_highlighting = false,
	},
	indent = { enable = true },
	incremental_selection = { enable = true },
		autopairs = { enable = true },
		context_commentstring = {
			enable = true,
			config = {
				c = "// %s",
				lua = "-- %s",
			},
		},
	}
)
