set clipboard^=unnamedplus
set number
set noswapfile
set lazyredraw
set matchpairs+=<:>
set updatetime=250
set splitbelow
set splitright
set notimeout
set cursorline
set cursorlineopt=number,screenline
set ignorecase
set scrolloff=5
set sidescroll=5
set shortmess+=aoIOWc
set nosmarttab
set ttimeoutlen=10
set nowritebackup
set undofile
set undolevels=1000
set undoreload=10000
set nrformats+=alpha
set listchars+=precedes:<,extends:>
set diffopt+=vertical
set diffopt+=algorithm:patience,indent-heuristic
set diffopt+=foldcolumn:0
set fillchars=diff:\ ,eob:\ ,stlnc:\ ,stl:\ ,vert:\│,msgsep:‾,
set formatoptions=cnqj
set completeopt=menu,menuone,noselect,noinsert
set title
set titlestring=%(%m%)\ %(%{expand(\"%:~\")}%)
let formatlistpat='^\s*\(\d\+[\]:.)}\t ]\|[*-][\t ]\)\s*'
match ErrorMsg '^\(<\|=\|>\)\{7\}\([^=].\+\)\?$'

set path+=**
set wildignore+=*_build/*
set wildignore+=**/coverage/*
set wildignore+=**/node_modules/*
set wildignore+=**/.git/*

" Superceded by telescope file browser plugin
" let g:netrw_browse_split = 0
" let g:netrw_banner = 0
" let g:netrw_keepdir = 0
" let g:netrw_winsize = 25
" let g:netrw_liststyle = 3
" let g:netrw_localrmdir='rm -r'
" let g:netrw_localcopydircmd = 'cp -r'
" nnoremap <silent><F5> :Vex!<cr>
